# Record Class CLNImageArrayDescription

java.lang.Object
java.lang.Record
com.io7m.calino.api.CLNImageArrayDescription

Record Components:
  `mipMapLevel` - The mipmap level
  `layer` - The layer
  `dataOffsetWithinSection` - The offset of the data from the start of the section data
  `dataSizeUncompressed` - The size of the uncompressed data
  `dataSizeCompressed` - The size of the supercompressed data
  `crc32Uncompressed` - The CRC32 of the uncompressed data

All Implemented Interfaces:
  `CLNImageDescriptionType, Comparable<CLNImageArrayDescription>`

public record CLNImageArrayDescription(int mipMapLevel, int layer, long dataOffsetWithinSection, long dataSizeUncompressed, long dataSizeCompressed, int crc32Uncompressed) extends Record implements CLNImageDescriptionType, Comparable<CLNImageArrayDescription>
A description of a single array image.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CLNImageArrayDescription(int mipMapLevel, int layer, long dataOffsetWithinSection, long dataSizeUncompressed, long dataSizeCompressed, int crc32Uncompressed)`
  Creates an instance of a `CLNImageArrayDescription` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(CLNImageArrayDescription other)`
  `int`
  `crc32Uncompressed()`
  Returns the value of the `crc32Uncompressed` record component.
  `long`
  `dataOffsetWithinSection()`
  Returns the value of the `dataOffsetWithinSection` record component.
  `long`
  `dataSizeCompressed()`
  Returns the value of the `dataSizeCompressed` record component.
  `long`
  `dataSizeUncompressed()`
  Returns the value of the `dataSizeUncompressed` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `int`
  `layer()`
  Returns the value of the `layer` record component.
  `int`
  `mipMapLevel()`
  Returns the value of the `mipMapLevel` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CLNImageArrayDescription

    public CLNImageArrayDescription(int mipMapLevel, int layer, long dataOffsetWithinSection, long dataSizeUncompressed, long dataSizeCompressed, int crc32Uncompressed)
    Creates an instance of a `CLNImageArrayDescription` record class.
    Parameters:
      `mipMapLevel` - the value for the `mipMapLevel` record component
      `layer` - the value for the `layer` record component
      `dataOffsetWithinSection` - the value for the `dataOffsetWithinSection` record component
      `dataSizeUncompressed` - the value for the `dataSizeUncompressed` record component
      `dataSizeCompressed` - the value for the `dataSizeCompressed` record component
      `crc32Uncompressed` - the value for the `crc32Uncompressed` record component

- ## Method Details

  - ### compareTo

    public int compareTo(CLNImageArrayDescription other)
    Specified by:
      `compareTo` in interface `Comparable<CLNImageArrayDescription>`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with the `compare` method from their corresponding wrapper classes.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### mipMapLevel

    public int mipMapLevel()
    Returns the value of the `mipMapLevel` record component.
    Specified by:
      `mipMapLevel` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `mipMapLevel` record component

  - ### layer

    public int layer()
    Returns the value of the `layer` record component.
    Returns:
      the value of the `layer` record component

  - ### dataOffsetWithinSection

    public long dataOffsetWithinSection()
    Returns the value of the `dataOffsetWithinSection` record component.
    Specified by:
      `dataOffsetWithinSection` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `dataOffsetWithinSection` record component

  - ### dataSizeUncompressed

    public long dataSizeUncompressed()
    Returns the value of the `dataSizeUncompressed` record component.
    Specified by:
      `dataSizeUncompressed` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `dataSizeUncompressed` record component

  - ### dataSizeCompressed

    public long dataSizeCompressed()
    Returns the value of the `dataSizeCompressed` record component.
    Specified by:
      `dataSizeCompressed` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `dataSizeCompressed` record component

  - ### crc32Uncompressed

    public int crc32Uncompressed()
    Returns the value of the `crc32Uncompressed` record component.
    Specified by:
      `crc32Uncompressed` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `crc32Uncompressed` record component